using System;
using System.Drawing;
using System.Drawing.Imaging;

namespace Game
{
	/// <summary>
	/// Summary description for Gfx_Button.
	/// </summary>
	public class Gfx_Button
	{
		public String text;
		public int text_size;

		public Bitmap icon;

		public bool shaded;

		public Rectangle area;

		public int user_data = -1;

		private Font font;

		public Gfx_Button( String text, int text_size, Rectangle rect, bool shaded )
		{
			this.text = text;
			this.text_size = text_size;

			this.shaded = shaded;

			area = rect;
		}

		public Gfx_Button( Bitmap icon, Rectangle rect, bool shaded )
		{
			this.icon = icon;

			this.shaded = shaded;

			area = rect;
		}

		public bool Is_In_Button( int x, int y )
		{
			return area.Contains( x, y );
		}

		public void Draw( Graphics g, bool selected )
		{
			if ( text != null && font == null )
			{
				font = new Font( "Comic Sans MS", text_size );
			}

			if ( shaded )
			{
				Brush b = new SolidBrush( Color.FromArgb( 130, 0, 0, 0 ) );
				g.FillRectangle( b, area );
			}

			if ( text != null )
			{
				int a = selected ? 255 : 150;
				Brush b = new SolidBrush( Color.FromArgb( a, 255, 255, 255 ) );

				Resources.Write_Center( g, b, font, text, area.X + ( area.Width / 2 ), area.Y + ( area.Height / 2 ) );
			}

			if ( icon != null )
			{
				Resources.Draw_Image_Center( g, icon, area.X + area.Width / 2, area.Y + area.Height / 2 );
			}
		}
	}
}
